using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace _2936
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public partial class Form1 : System.Windows.Forms.Form
    {
        private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
        private System.Windows.Forms.Button button1;
        /// <summary>
        /// Required designer variable.
        /// </summary>

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                | System.Windows.Forms.AnchorStyles.Left)
                | System.Windows.Forms.AnchorStyles.Right);
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.gridControl1.ColCount = 15;
            this.gridControl1.Location = new System.Drawing.Point(40, 32);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.RowCount = 60;
            this.gridControl1.Size = new System.Drawing.Size(432, 256);
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            // 
            // button1
            // 
            this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
            this.button1.Location = new System.Drawing.Point(224, 304);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(88, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Print Preview";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(512, 333);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.gridControl1});
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            //printpreview
            if (gridControl1 != null)
            {
                try
                {
                    GridPrintAtLocDocument pd = new GridPrintAtLocDocument(gridControl1, true); //Assumes the default printer 
                    PrintPreviewDialog dlg = new PrintPreviewDialog();
                    dlg.Document = pd;
                    dlg.ShowDialog();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error occurred attempting to preview - " + ex.Message);
                }
            }
        }
    }

    public class GridPrintAtLocDocument : GridPrintDocument
    {
        private GridControlBase _grid;

        private int headerHeight;

        private int footerHeight;

        private int pageNo;

        public GridPrintAtLocDocument(GridControlBase grid, bool printPreview)
            : base(grid, printPreview)
        {
            _grid = grid;

            headerHeight = 180;
            footerHeight = 20;

            int left = this.DefaultPageSettings.Margins.Left;
            int top = this.DefaultPageSettings.Margins.Top + headerHeight;  //50 lower
            int right = this.DefaultPageSettings.Margins.Right;
            int bottom = this.DefaultPageSettings.Margins.Bottom;
            this.DefaultPageSettings.Margins = new Margins(left, right, top, bottom);

            pageNo = 1;
        }

        protected override void OnPrintPage(System.Drawing.Printing.PrintPageEventArgs ev)
        {            
            base.OnPrintPage(ev);
            Font font;
            //compute the position of the header
            float x = (float)this.DefaultPageSettings.Bounds.X;//this.DefaultPageSettings.Margins.Left;
            float y = (float)this.DefaultPageSettings.Margins.Top - headerHeight - 30;
            float w = (float)this.DefaultPageSettings.Bounds.Width;
            float h = (float)headerHeight + 30;

            //setup the alignment
            StringFormat format = new StringFormat();
            format.LineAlignment = StringAlignment.Center;
            format.Alignment = StringAlignment.Center;

            //define the header text and draw it
            string text = "";
            if (pageNo == 1)
            {
                text = string.Format(" Header Text 1 \n Header Text 2 \n Header Text 3 \n Header Text 4 ");
                font = new Font(_grid.Font.Name, 30);
                ev.Graphics.DrawString(text, font, Brushes.Black, new RectangleF(x, y, w, h), format);                
            }            

            //position the footer; align the footer ; print the footer
            y = (float)(this.DefaultPageSettings.Bounds.Top + this.DefaultPageSettings.Bounds.Height - footerHeight);// Margins.Top - headerHeight - 30;
            h = (float)footerHeight;

            format.Alignment = StringAlignment.Center;
            // Gets the page No. with the Maximum Page
            text = string.Format("Footer Text {0} of {1}", pageNo, this.PrinterSettings.MaximumPage);
            font = new Font(_grid.Font.Name, 10);
            ev.Graphics.DrawString(text, font, Brushes.Black, new RectangleF(x, y, w, h), format);

            pageNo++;
        }

    }
}